#include <stdio.h>
#include <stdlib.h>

#include "graph.h"

int cmp(const void *a, const void *b)
{
	return ((a == b) ? 0 : 1);
}

int
main()
{
	graph *gp;
	graph_node *n[3];
	graph_edge *e[3];
	graph_node node;
	graph_edge edge;

	int i;

	gp = graph_new();
	if (gp == NULL) {
		printf("no memory for graph\n");

		return 1;
	}

	for (i = 0; i < 3; i++) {
		n[i] = graph_new_node();
		if (n[i] == NULL) {
			printf("no memory for node %i\n", i);
			goto error;
		}

		graph_set_node_data(n[i], n[i]);

		if (graph_add_node(gp, n[i]) != GRAPH_OK) {
			free(n[i]);
			printf("no memory to add node %i\n", i);
			goto error;
		}

		printf("node %i was added\n", i);
	}

	printf("\n");

	for (i = 0; i < 3; i++) {
		e[i] = graph_new_edge();
		if (e[i] == NULL) {
			printf("no memory for edge %i\n", i);
			goto error;
		}

		graph_set_edge_data(e[i], (void *)((i+1)*50));
		graph_set_edge_src(e[i], n[i]);
		graph_set_edge_dst(e[i], n[(i+1)%3]);

		if (graph_add_edge(e[i]) != GRAPH_OK) {
			printf("no memory to add edge %i\n", i);
			free(e[i]);

			goto error;
		}

		printf("edge %i was added\n", i);
	}

	printf("\n");

	for (i = 0; i < 3; i++) {

		node.data = n[i];
		n[i] = graph_lookup_node(gp, &node, cmp, 0);
		printf("node %i\n", i);
		printf("\tdata:\t\t%p\n", n[i]->data);
		printf("\tin_edges:\t%p\n", n[i]->in_edges);
		printf("\tout_edges:\t%p\n\n", n[i]->out_edges);
	}

	for (i = 0; i < 3; i++) {
		edge.data = (void *)((i+1)*50);
		edge.src = n[i];
		edge.dst = n[(i+1)%3];

		e[i] = graph_lookup_edge(&edge, cmp, 0);
		printf("edge %i: data = %p\n", i, e[i]->data);
	}

error:
	graph_free(&gp);

	return 0;
}

